package cn.estsh.i3plus.core.apiservice.daoimpl;

import cn.estsh.i3plus.core.apiservice.dao.IReportDao;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.List;
import java.util.Map;

/**
 * @Description :
 * @Reference :
 * @Author : Adair Peng
 * @CreateDate : 2019-01-20 16:14
 * @Modify:
 **/
@Service
public class ReportDaoImpl implements IReportDao {

    public static final Logger LOGGER = LoggerFactory.getLogger(ReportDaoImpl.class);

    @Autowired
    private EntityManager entityManager;

    @Override
    public List<Object[]> findByHqlObjects(String hql, Map<String,Object> findParam) throws Exception {
        LOGGER.info(" find HQL:{} \n find params :{}", hql, findParam);
        Query queryObject = entityManager.createQuery(hql);

        if(CollectionUtils.isEmpty(findParam)){
            findParam.forEach((K, V) -> queryObject.setParameter(K, V));
        }

        entityManager.clear();
        return queryObject.getResultList();
    }

    @Override
    public Long findByHqlCount(String hql, Map<String, Object> findParam) throws Exception {
        LOGGER.info(" find HQL:{} \n find params :{}", hql, findParam);
        Query queryObject = entityManager.createQuery(hql);

        if(CollectionUtils.isEmpty(findParam)){
            findParam.forEach((K, V) -> queryObject.setParameter(K, V));
        }

        entityManager.clear();
        return (Long)queryObject.getSingleResult();
    }
}
